package com.mortals.xhx.module.user.model;

import java.util.List;
import java.util.ArrayList;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.mortals.framework.annotation.Excel;
import com.mortals.framework.model.BaseEntityLong;
import com.mortals.xhx.module.user.model.vo.UserCollectVo;
/**
 * 用户收藏夹实体对象
 *
 * @author zxfei
 * @date 2023-03-13
 */

public class UserCollectEntity extends UserCollectVo {
    private static final long serialVersionUID = 1L;

    /**
     * 用户id
     */
    private Long userId;
    /**
     * 收藏类型1单事项2一件事
     */
    private Integer collectType;
    /**
     * 收藏名称
     */
    private String collectName;
    /**
     * 收藏链接
     */
    private String collectUrl;
    /**
     * 收藏关联业务id
     */
    private String businessId;



    public UserCollectEntity(){}
    /**
     * 获取 用户id
     * @return Long
     */
    public Long getUserId(){
        return userId;
    }
    /**
     * 设置 用户id
     * @param userId
     */
    public void setUserId(Long userId){
        this.userId = userId;
    }
    /**
     * 获取 收藏类型1单事项2一件事
     * @return Integer
     */
    public Integer getCollectType(){
        return collectType;
    }
    /**
     * 设置 收藏类型1单事项2一件事
     * @param collectType
     */
    public void setCollectType(Integer collectType){
        this.collectType = collectType;
    }
    /**
     * 获取 收藏名称
     * @return String
     */
    public String getCollectName(){
        return collectName;
    }
    /**
     * 设置 收藏名称
     * @param collectName
     */
    public void setCollectName(String collectName){
        this.collectName = collectName;
    }
    /**
     * 获取 收藏链接
     * @return String
     */
    public String getCollectUrl(){
        return collectUrl;
    }
    /**
     * 设置 收藏链接
     * @param collectUrl
     */
    public void setCollectUrl(String collectUrl){
        this.collectUrl = collectUrl;
    }
    /**
     * 获取 收藏关联业务id
     * @return String
     */
    public String getBusinessId(){
        return businessId;
    }
    /**
     * 设置 收藏关联业务id
     * @param businessId
     */
    public void setBusinessId(String businessId){
        this.businessId = businessId;
    }




    @Override
    public int hashCode() {
        return this.getId().hashCode();
    }
    @Override
    public boolean equals(Object obj) {
        if (obj == null) return false;
        if (obj instanceof UserCollectEntity) {
            UserCollectEntity tmp = (UserCollectEntity) obj;
            if (this.getId() == tmp.getId()) {
                return true;
            }
        }
        return false;
    }

    public String toString(){
        StringBuilder sb = new StringBuilder("");
        sb.append(",userId:").append(getUserId());
        sb.append(",collectType:").append(getCollectType());
        sb.append(",collectName:").append(getCollectName());
        sb.append(",collectUrl:").append(getCollectUrl());
        sb.append(",businessId:").append(getBusinessId());
        return sb.toString();
    }

    public void initAttrValue(){

        this.userId = null;

        this.collectType = 1;

        this.collectName = "";

        this.collectUrl = "";

        this.businessId = "";
    }
}