package com.mortals.xhx.module.user.web;
import com.mortals.framework.annotation.RepeatSubmit;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.service.IUser;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.module.user.model.UserCollectQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.user.model.UserCollectEntity;
import com.mortals.xhx.module.user.service.UserCollectService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.*;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 用户收藏夹
*
* @author zxfei
* @date 2023-03-09
*/
@RestController
@RequestMapping("user/collect")
public class UserCollectController extends BaseCRUDJsonBodyMappingController<UserCollectService,UserCollectEntity,Long> {

    @Autowired
    private ParamService paramService;

    public UserCollectController(){
        super.setModuleDesc( "用户收藏夹");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "collectType", paramService.getParamBySecondOrganize("UserCollect","collectType"));
        super.init(model, context);
    }

    @PostMapping({"remove"})
    @RepeatSubmit
    public String remove(@RequestBody UserCollectEntity entity) {
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "单事项取消收藏";
        IUser user = this.getCurUser();
        if(user==null){
            throw new AppException("用户未登录");
        }
        int code = 1;
        try {
            UserCollectEntity remove = new UserCollectEntity();
            remove.setUserId(user.getId());
            remove.setBusinessId(entity.getAssistId()+"");
            UserCollectEntity delete = service.selectOne(remove);
            if(delete!=null) {
                this.service.remove(delete.getId(), context);
            }
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】 [userId:" + user.getId() + ",MatterId:"+entity.getMatterId()+"]");
        } catch (Exception var7) {
            this.doException(this.request, busiDesc, model, var7);
            code=-1;
        }

        this.init(model, context);
        JSONObject ret = new JSONObject();
        ret.put("code", code);
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }
}