package com.mortals.xhx.common.code;

import java.util.LinkedHashMap;
import java.util.Map;


public enum OnlineEnum {
    在线("zx", "在线"),
    离线("lx", "离线"),
    暂离("zl", "暂离");
    private String value;
    private String desc;

    OnlineEnum(String value, String desc) {
        this.value = value;
        this.desc = desc;
    }

    public String getValue() {
        return this.value;
    }

    public String getDesc() {
        return this.desc;
    }

    public static OnlineEnum getByValue(String value) {
        for (OnlineEnum onlineEnum : OnlineEnum.values()) {
            if (onlineEnum.getValue() == value) {
                return onlineEnum;
            }
        }
        return null;
    }

    /**
    * 获取Map集合
    *
    * @param eItem 不包含项
    * @return
    */
    public static Map<String, String> getEnumMap(String... eItem) {
        Map<String, String> resultMap = new LinkedHashMap<>();
        for (OnlineEnum item : OnlineEnum.values()) {
            try {
                boolean hasE = false;
                for (String e : eItem) {
                    if (item.getValue() == e) {
                        hasE = true;
                        break;
                    }
                }
                if (!hasE) {
                    resultMap.put(item.getValue() + "", item.getDesc());
                }
            } catch (Exception ex) {

            }
        }
        return resultMap;
    }
}