package com.mortals.xhx.module.app.dao.ibatis;


import com.mortals.framework.model.PageInfo;
import com.mortals.framework.model.ParamDto;
import com.mortals.framework.model.Result;
import com.mortals.xhx.module.app.model.AppDatasetQuery;
import com.mortals.xhx.module.app.model.AppInfoFieldEntity;
import com.mortals.xhx.module.matter.model.MatterEntity;
import org.apache.ibatis.session.RowBounds;
import org.springframework.stereotype.Repository;
import com.mortals.xhx.module.app.dao.AppDatasetDao;
import com.mortals.xhx.module.app.model.AppDatasetEntity;

import java.util.ArrayList;
import java.util.Date;
import com.mortals.framework.dao.ibatis.BaseCRUDDaoMybatis;
import java.util.List;
/**
* 自助终端应用数据集DaoImpl DAO接口
*
* @author zxfei
* @date 2022-11-28
*/
@Repository("appDatasetDao")
public class AppDatasetDaoImpl extends BaseCRUDDaoMybatis<AppDatasetEntity,Long> implements AppDatasetDao {

    @Override
    public Result<AppInfoFieldEntity> getCustomList(AppDatasetQuery appDatasetQuery, PageInfo pageInfo) {
        Result<AppInfoFieldEntity> result = new Result();
        ParamDto paramDto = this.getQueryParam(appDatasetQuery);
        int count = this.getCustomCount(paramDto);
        List list = null;
        if (count == 0) {
            list = new ArrayList();
        } else if (pageInfo.getPrePageResult() == -1) {
            list = this.getSqlSession().selectList(this.getSqlId(SQLID_CUSTOM_LIST), paramDto);
        } else {
            list = this.getSqlSession().selectList(this.getSqlId(SQLID_CUSTOM_LIST), paramDto);
/*            RowBounds rowBounds = new RowBounds(pageInfo.getBeginIndex(), pageInfo.getPrePageResult());
            list = this.getSqlSession().selectList(this.getSqlId(SQLID_CUSTOM_LIST), this.cpyQueryParamDto(paramDto), rowBounds);*/
        }
        pageInfo.setTotalResult(count);
        result.setPageInfo(pageInfo);
        result.setList(list);
        return result;
    }

    public int getCustomCount(ParamDto paramDto) {
        return this.getSqlSession().selectOne(this.getSqlId(SQLID_CUSTOM_COUNT), this.cpyQueryParamDto(paramDto));
    }
}
