package com.mortals.xhx.module.apply.web;
import com.mortals.framework.annotation.RepeatSubmit;
import com.mortals.framework.annotation.UnAuth;
import com.mortals.framework.common.Rest;
import com.mortals.framework.model.BaseEntity;
import com.mortals.framework.model.PageInfo;
import com.mortals.framework.model.Result;
import com.mortals.framework.service.IUser;
import com.mortals.framework.utils.BeanUtil;
import com.mortals.framework.utils.ReflectUtils;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.apply.model.MatterApplyEntity;
import com.mortals.xhx.module.apply.service.MatterApplyService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.*;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 单事项申报
*
* @author zxfei
* @date 2023-05-23
*/
@RestController
@RequestMapping("matter/apply")
public class MatterApplyController extends BaseCRUDJsonBodyMappingController<MatterApplyService,MatterApplyEntity,Long> {

    @Autowired
    private ParamService paramService;

    public MatterApplyController(){
        super.setModuleDesc( "单事项申报");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "applyType", paramService.getParamBySecondOrganize("MatterApply","applyType"));
        this.addDict(model, "applyState", paramService.getParamBySecondOrganize("MatterApply","applyState"));
        this.addDict(model, "sexual", paramService.getParamBySecondOrganize("MatterApply","sexual"));
        super.init(model, context);
    }

    @PostMapping({"save"})
    @RepeatSubmit
    @UnAuth
    public String save(@RequestBody MatterApplyEntity entity) {
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "保存" + this.getModuleDesc();

        int code;
        try {
            this.saveBefore(entity, model, context);
            if (entity.newEntity()) {
                Class<MatterApplyEntity> tClass = ReflectUtils.getClassGenricType(this.getClass(), 1);
                MatterApplyEntity initEntity = (MatterApplyEntity)tClass.newInstance();
                initEntity.initAttrValue();
                BeanUtils.copyProperties(entity, initEntity, BeanUtil.getNullPropertyNames(entity));
                entity = initEntity;
                busiDesc = "新增" + this.getModuleDesc();
                initEntity.setCreateTime(new Date());
                initEntity.setUpdateTime(initEntity.getCreateTime());
                IUser user = this.getCurUser();
                if (user != null) {
                    initEntity.setCreateUserId(user.getId());
                    initEntity.setCreateUser(user.getLoginName());
                    initEntity.setCreateUserName(user.getRealName());
                    initEntity.setCreateUserDeptId(user.getDeptId());
                    initEntity.setCreateUserDeptName(user.getDeptName());
                    initEntity.setUpdateUserId(user.getId());
                    initEntity.setUpdateUser(user.getLoginName());
                    initEntity.setUpdateUserName(user.getRealName());
                    initEntity.setUpdateUserDeptId(user.getDeptId());
                    initEntity.setUpdateUserDeptName(user.getDeptName());
                }

                this.service.save(initEntity, context);
            } else {
                busiDesc = "修改" + this.getModuleDesc();
                entity.setUpdateTime(new Date());
                IUser user = this.getCurUser();
                if (user != null) {
                    entity.setUpdateUserId(user.getId());
                    entity.setUpdateUser(user.getLoginName());
                    entity.setUpdateUserName(user.getRealName());
                    entity.setUpdateUserDeptId(user.getDeptId());
                    entity.setUpdateUserDeptName(user.getDeptName());
                }

                this.service.update(entity, context);
            }

            model.put("id", entity.getId());
            code = this.saveAfter(entity, model, context);
            model.put("entity", entity);
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + entity.getId() + "]");
        } catch (Exception var9) {
            this.doException(this.request, busiDesc, model, var9);
            model.put("entity", entity);
            this.init(model, context);
            code = this.saveException(entity, model, context, var9);
        }

        this.init(model, context);
        JSONObject ret = new JSONObject();
        ret.put("code", code);
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }

    /**
     * 审批
     * @param entity
     * @return
     */
    @PostMapping({"examine"})
    public String applyExamine(@RequestBody MatterApplyEntity entity) {
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "审批" + this.getModuleDesc();

        int code;
        try {
            this.service.applyExamine(entity,context);
            model.put("id", entity.getId());
            code = this.saveAfter(entity, model, context);
            model.put("entity", entity);
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + entity.getId() + "]");
        } catch (Exception var9) {
            this.doException(this.request, busiDesc, model, var9);
            model.put("entity", entity);
            this.init(model, context);
            code = this.saveException(entity, model, context, var9);
        }

        this.init(model, context);
        JSONObject ret = new JSONObject();
        ret.put("code", code);
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }

    /**
     * 重新申请
     * @param entity
     * @return
     */
    @PostMapping({"reApply"})
    @RepeatSubmit
    @UnAuth
    public String reApply(@RequestBody MatterApplyEntity entity) {
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "重新申请" + this.getModuleDesc();

        int code;
        try {
            this.service.reApply(entity,context);
            model.put("id", entity.getId());
            code = this.saveAfter(entity, model, context);
            model.put("entity", entity);
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + entity.getId() + "]");
        } catch (Exception var9) {
            this.doException(this.request, busiDesc, model, var9);
            model.put("entity", entity);
            this.init(model, context);
            code = this.saveException(entity, model, context, var9);
        }

        this.init(model, context);
        JSONObject ret = new JSONObject();
        ret.put("code", code);
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }

    @RequestMapping(
            value = {"delete"},
            method = {RequestMethod.POST, RequestMethod.GET}
    )
    @UnAuth
    public String delete(Long[] id) {
        Context context = this.getContext();
        if (id == null) {
            return this.createFailJsonResp("请至少选择一条记录");
        } else {
            Map<String, Object> model = new HashMap();
            int code = 1;
            String busiDesc = "删除" + this.getModuleDesc();

            try {
                this.deleteBefore(id, context);
                int iRet = this.service.remove(id, context);
                model.put("message_info", this.getModuleDesc() + "删除成功!删除条数:" + iRet);
                this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + StringUtils.converArray2Str(id) + "]");
            } catch (Exception var7) {
                code = -1;
                this.doException(this.request, busiDesc, model, var7);
            }

            JSONObject ret = new JSONObject();
            ret.put("code", Integer.valueOf(code));
            ret.put("msg", model.remove("message_info"));
            ret.put("data", model);
            return ret.toJSONString();
        }
    }

    @PostMapping({"list"})
    @UnAuth
    public Rest<Object> list(@RequestBody MatterApplyEntity query) {
        Rest<Object> ret = new Rest();
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "查询" + this.getModuleDesc();

        int code;
        try {
            this.doListBefore(query, model, context);
            PageInfo pageInfo = this.buildPageInfo(query);
            Result<MatterApplyEntity> result = this.getService().find(query, pageInfo, context);
            this.doListAfter(query, result.getList(), context);
            model.put("data", result.getList());
            model.put("pageInfo", result.getPageInfo());
            this.parsePageInfo(model, result.getPageInfo());
            code = this.doListAfter(query, (Map)model, context);
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】");
        } catch (Exception var9) {
            code = -1;
            this.doException(this.request, busiDesc, model, var9);
        }

        this.init(model, context);
        ret.setCode(code);
        ret.setData(model);
        ret.setDict(model.get("dict"));
        ret.setMsg(model.get("message_info") == null ? "" : model.remove("message_info").toString());
        return ret;
    }

}